package com.EmergencyAlertApplication.EAA.Entities;

import jakarta.persistence.*;
import java.util.List;

@Entity
@Table(name = "alerts")
public class Alert {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String reason;            // What happened
    private String animals;           // Which animal
    private String location;          // Where it happened
    private String directions;        // Directions
    private String firstName;         // First name
    private String lastName;          // Last name
    private String phone;             // Phone number
    private String email;             // Email address
    private boolean canWait;          // Can wait at location
    private Double latitude;
    private Double longitude;

    @ElementCollection
    private List<String> pictures;    // List of image file paths or URLs

    // Constructors, getters, and setters
    public Alert() {}

    public Alert(String reason, String animals, String location, String directions,
                 String firstName, String lastName, String phone, String email,
                 boolean canWait, List<String> pictures) {
        this.reason = reason;
        this.animals = animals;
        this.location = location;
        this.directions = directions;
        this.firstName = firstName;
        this.lastName = lastName;
        this.phone = phone;
        this.email = email;
        this.canWait = canWait;
        this.pictures = pictures;
    }

    // Getters and setters
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public String getAnimals() {
        return animals;
    }

    public void setAnimals(String animals) {
        this.animals = animals;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getDirections() {
        return directions;
    }

    public void setDirections(String directions) {
        this.directions = directions;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public boolean isCanWait() {
        return canWait;
    }

    public void setCanWait(boolean canWait) {
        this.canWait = canWait;
    }

    public List<String> getPictures() {
        return pictures;
    }

    public void setPictures(List<String> pictures) {
        this.pictures = pictures;
    }

    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    public Double getLongitude() {
        return longitude;
    }

    public void setLongitude(Double longitude) {
        this.longitude = longitude;
    }
}
