package com.EmergencyAlertApplication.EAA.Services;

import com.EmergencyAlertApplication.EAA.Entities.Alert; // Eeldame, et teil on Alert entity
import com.EmergencyAlertApplication.EAA.Repositories.AlertRepository; // Eeldame, et teil on AlertRepository
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class AlertService {

    private final AlertRepository alertRepository;

    @Autowired
    public AlertService(AlertRepository alertRepository) {
        this.alertRepository = alertRepository;
    }

    // Salvesta uus Alert objekt
    public Alert save(Alert alert) {
        return alertRepository.save(alert);
    }

    // Leia kõik Alert objektid (nt vajadusel)
    public List<Alert> findAll() {
        return alertRepository.findAll();
    }

    // Leia Alert objekti ID järgi (nt vajadusel)
    public Optional<Alert> findById(Long id) { // Oletame, et ID tüüp on Long
        return alertRepository.findById(id);
    }

    // Kustuta Alert objekt ID järgi (nt vajadusel)
    public void deleteById(Long id) {
        alertRepository.deleteById(id);
    }
}
