package com.EmergencyAlertApplication.EAA.Services;


import com.google.api.client.googleapis.javanet.GoogleNetHttpTransport;
import com.google.api.client.googleapis.json.GoogleJsonResponseException;
import com.google.api.client.http.FileContent;
import com.google.api.client.http.javanet.NetHttpTransport;
import com.google.api.services.drive.Drive;
import com.google.api.services.drive.DriveScopes;
import com.google.api.services.drive.model.File;
import com.google.auth.http.HttpCredentialsAdapter;
import com.google.auth.oauth2.GoogleCredentials;
import org.springframework.web.multipart.MultipartFile;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.GeneralSecurityException;
import java.util.Collections;
import static com.EmergencyAlertApplication.EAA.DriveQuickstart.*;


public class GoogleDriveService {

    private static final String SERVICE_ACCOUNT_FILE = "src/main/resources/tarkvaraprojekti.json";


    public static String uploadFile(String fileName, MultipartFile file, String folderId) throws IOException, GeneralSecurityException {
        final NetHttpTransport HTTP_TRANSPORT = GoogleNetHttpTransport.newTrustedTransport();
        Drive service = GoogleDriveService.getDriveService();


        File fileMetadata = new File();
        fileMetadata.setName(fileName);
        fileMetadata.setParents(Collections.singletonList(folderId));

        java.io.File tempFile = new java.io.File(file.getOriginalFilename());
        try (FileOutputStream outputStream = new FileOutputStream(tempFile)) {
            outputStream.write(file.getBytes());
        }

        FileContent mediaContent = new FileContent(file.getContentType(), tempFile);

        try {
            File uploadedFile = service.files().create(fileMetadata, mediaContent)
                    .setFields("id")
                    .execute();
            return uploadedFile.getId();
        } catch (GoogleJsonResponseException e) {
            throw new IOException("Unable to upload file: " + e.getDetails());
        }
    }
    public static Drive getDriveService() throws IOException {
        // Laadige teenusekonto võtmefail
        GoogleCredentials credentials = GoogleCredentials.fromStream(new FileInputStream(SERVICE_ACCOUNT_FILE))
                .createScoped(Collections.singleton(DriveScopes.DRIVE));

        // Looge Drive teenus
        try {
            return new Drive.Builder(GoogleNetHttpTransport.newTrustedTransport(), JSON_FACTORY, new HttpCredentialsAdapter(credentials))
                    .setApplicationName(APPLICATION_NAME)
                    .build();
        } catch (GeneralSecurityException e) {
            throw new RuntimeException(e);
        }
    }
}

